{-# OPTIONS_GHC -Wno-missing-signatures #-}
module Functions
  ( isImageFilename
  , convertedImageFilename
  , listDirectory
  , openImage
  , convertImage
  , saveFile
  , runPandoc
  ) where

import Types
import ComputationM

data IsImageFilename = IsImageFilename deriving (Show)
instance IsFunction IsImageFilename FilePath Bool where
  runF IsImageFilename _path = undefined

data ConvertedImageFilename = ConvertedImageFilename deriving (Show)
instance IsFunction ConvertedImageFilename FilePath FilePath where
  runF ConvertedImageFilename _path = undefined


data ListDirectory = ListDirectory deriving (Show)
instance IsFunctionIO ListDirectory FilePath [FilePath] where
  runFIO ListDirectory _path = undefined

data OpenImage = OpenImage deriving (Show)
instance IsFunctionIO OpenImage FilePath Image where
  runFIO OpenImage _path = undefined

data ConvertImage = ConvertImage deriving (Show)
instance IsFunctionIO ConvertImage Image Image where
  runFIO ConvertImage _image = undefined

data SaveFile = SaveFile deriving (Show)
instance IsFunctionIO SaveFile (String, FilePath) () where
  runFIO SaveFile _source = undefined

data RunPandoc = RunPandoc deriving (Show)
instance IsFunctionIO RunPandoc String String where
  runFIO RunPandoc _source = undefined


isImageFilename = runFunction IsImageFilename
convertedImageFilename = runFunction ConvertedImageFilename

listDirectory = runFunctionIO ListDirectory
openImage = runFunctionIO OpenImage
convertImage = runFunctionIO ConvertImage
saveFile = runFunctionIO SaveFile
runPandoc = runFunctionIO RunPandoc
